﻿using System.Collections.ObjectModel;

// Using custom type converters with C# and YamlDotNet, part 1
// http://www.cyotek.com/blog/using-custom-type-converters-with-csharp-and-yamldotnet-part-1

// This work is licensed under the Creative Commons Attribution 4.0 International License.
// To view a copy of this license, visit http://creativecommons.org/licenses/by/4.0/.

namespace YamlDotNetTypeConverter
{
  internal sealed class ContentCategoryCollection : Collection<ContentCategory>
  {
    #region Fields

    private ContentCategory _parent;

    #endregion

    #region Properties

    public ContentCategory Parent
    {
      get { return _parent; }
      set
      {
        _parent = value;

        foreach (ContentCategory item in this)
        {
          item.Parent = value;
        }
      }
    }

    #endregion

    #region Methods

    protected override void InsertItem(int index, ContentCategory item)
    {
      item.Parent = _parent;

      base.InsertItem(index, item);
    }

    #endregion
  }
}
